<template>
  <div class="countdown">
    <div class="block">
      <p class="digit">{{ duration.asDays() | two_digits }}</p>
      <p class="text">days</p>
    </div>
    <div class="double-dot">:</div>
    <div class="block">
      <p class="digit">{{ duration.hours() | two_digits }}</p>
      <p class="text">hrs</p>
    </div>
    <div class="double-dot">:</div>
    <div class="block">
      <p class="digit">{{ duration.minutes() | two_digits }}</p>
      <p class="text">min</p>
    </div>
    <div class="double-dot">:</div>
    <div class="block sec">
      <p class="digit">{{ duration.seconds() | two_digits }}</p>
      <p class="text">sec</p>
    </div>
  </div>
</template>

<script>
  import moment from 'moment';
  import bignumber from 'bignumber.js';

  export default {
    props: {
      targetTime: {
        type: Number
      }
    },
    data() {
      return {
        duration: moment.duration(0)
      }
    },
    mounted() {
      window.setInterval(() => {
        this.duration = moment.duration(moment(this.targetTime).diff(moment()));
      },1000);
    },
    filters: {
      two_digits: function (value) {
        value = bignumber(`${value}`).integerValue(bignumber.ROUND_DOWN).toNumber();
        if (!value || value < 0) {
          return '00';
        }
        if (value.toString().length <= 1) {
          return `0${value}`;
        }
        return value;
      }
    }
  }
</script>
<style lang="scss" scoped>
  @import '../../../../sass/variables';
  @import '../../../../sass/vendor/position';
  * {
    margin: 0;
    padding: 0;
  }
  .countdown {
    text-align: center;

    margin-bottom: 23px;
  }

  .block {
    display: inline-block;
    vertical-align: middle;
    margin: 0 9px;

    &.sec .digit {
      color: $orange;
    }
  }

  .digit {
    font-size: $agiant;
    font-weight: 300;
    color: $white;
    line-height: 1;
    min-width: 65px;
  }

  .text {
    color: $gray_text_dashboard;
    font-size: 14px;
    margin-top: -3px;
  }

  .double-dot {
    display: inline-block;
    color: $gray_text_dashboard;
    font-size: $font20;
    font-weight: bold;
    vertical-align: middle;
    margin-top: -21px;
  }
</style>
